const wait = (delay) => new Promise((res) => {
    setTimeout(() => {
        res();
    }, delay);
});
export const throttle = (delay = 500) => {
    let last = 0;
    return function (target, propertyKey, descriptor) {
        const origin = descriptor?.value;
        descriptor.value = async function (...args) {
            const now = Date.now();
            let rest = Math.max(0, delay - (now - last));
            await wait(rest);
            last = Date.now();
            return origin.apply(this, args);
        };
    };
};
